%define shortname live
%define name %{shortname}555
%define version 0.0.0
%define snapshot 2009.04.20
%define release alt0.%snapshot.1

%define live_soversion 0

Summary: Live555.com Streaming Media Library Utilities
Name: %name
Version: %version
Release: %release
License: LGPL
Group: System/Libraries
Url: http://www.live555.com/liveMedia/

Packager: Pavlov Konstantin <thresh@altlinux.ru>
Source0: %name.tar.bz2

# renamed...
Provides: live = %version-%release
Obsoletes: live < %version-%release

# Automatically added by buildreq on Sat Dec 10 2005
BuildRequires: gcc-c++ libstdc++-devel

%description
This code forms a set of C++ libraries for multimedia streaming, using
open standard protocols (RTP/RTCP, RTSP, SIP). These libraries - which
can be compiled for Unix (including Linux and Mac OS X), Windows, and
QNX (and other POSIX-compliant systems) - can be used to build
streaming applications.

This package contains the example apps of live555.com.

%package -n lib%name-%live_soversion
Summary: Live555.com Streaming Media Library
Group: System/Libraries
Provides: lib%name = %version-%release

%description -n lib%name-%live_soversion
This code forms a set of C++ libraries for multimedia streaming, using
open standard protocols (RTP/RTCP, RTSP, SIP). These libraries - which
can be compiled for Unix (including Linux and Mac OS X), Windows, and
QNX (and other POSIX-compliant systems) - can be used to build
streaming applications.

This package contains live555 libraries.

%package -n lib%name-devel
Summary: Development files of the Live555.com Streaming Media Library
Group: Development/C++

Provides: liblive-devel = %version-%release
Obsoletes: liblive-devel < %version-%release

%description -n lib%name-devel
This code forms a set of C++ libraries for multimedia streaming, using
open standard protocols (RTP/RTCP, RTSP, SIP). These libraries - which
can be compiled for Unix (including Linux and Mac OS X), Windows, and
QNX (and other POSIX-compliant systems) - can be used to build
streaming applications.

This package contains all needed files to build programs based on live555.com.

%package -n lib%name-devel-static
Summary: Static development files of the Live555.com Streaming Media Library
Group: Development/C++
Requires: lib%name-devel = %version-%release

%description -n lib%name-devel-static
This code forms a set of C++ libraries for multimedia streaming, using
open standard protocols (RTP/RTCP, RTSP, SIP). These libraries - which
can be compiled for Unix (including Linux and Mac OS X), Windows, and
QNX (and other POSIX-compliant systems) - can be used to build
streaming applications.

This package contains all needed files to build programs based on live555.com.

%prep
%setup -q -n %name

rm -f testProgs/qtParse

%build
./genMakefiles linux.static
make clean
make RPM_OPT_FLAGS="%optflags"

mv $(find BasicUsageEnvironment groupsock liveMedia UsageEnvironment -name "*.a" ) $(pwd)

make clean

# Hack to prevent undefined-non-weak-symbol
for i in groupsock liveMedia ; do
  pushd $i
  LIBADD="-lstdc++ -lpthread"
  for j in BasicUsageEnvironment groupsock liveMedia UsageEnvironment ; do
    if [ $(grep $j Makefile.head |wc -l) = 1 ] ; then
      LIBADD="$LIBADD -L../${j} -l${j}"
    fi
  done
  echo -e LIBADDS = " $LIBADD " >> Makefile.head
  popd
  pushd UsageEnvironment
    echo -e LIBADDS = -lstdc++ -L../BasicUsageEnvironment -lBasicUsageEnvironment >> Makefile.head
  popd
  pushd BasicUsageEnvironment
    echo -e LIBADDS = -lstdc++ -lpthread  >> Makefile.head
  popd
done

./genMakefiles %_target_os

make CFLAGS="%optflags -fPIC -DPIC" SO_VERSION="%live_soversion"

# Hack to fix the circle dependency - we leave the safe parallele work here.
pushd BasicUsageEnvironment
rm *.so
make CFLAGS="$RPM_OPT_FLAGS -fPIC -DPIC" SO_VERSION="%live_soversion" \
    LIBADDS="-lstdc++ -lpthread -L../UsageEnvironment -lUsageEnvironment"
popd

%install

mkdir -p %buildroot%_libdir

for i in BasicUsageEnvironment groupsock liveMedia UsageEnvironment ; do
  install -dm 755 $RPM_BUILD_ROOT%_includedir/$i
  install -pm 644 $i/include/*.h* $RPM_BUILD_ROOT%_includedir/$i/
  install -pm 644 lib${i}.a $RPM_BUILD_ROOT%_libdir/lib${i}.a
  install -pm 755 $i/lib${i}.so $RPM_BUILD_ROOT%_libdir/lib${i}.so.%snapshot
  ln -sf lib${i}.so.%snapshot $RPM_BUILD_ROOT%_libdir/lib${i}.so.%live_soversion
  ln -sf lib${i}.so.%snapshot $RPM_BUILD_ROOT%_libdir/lib${i}.so
done

mkdir -p %buildroot%_bindir
for testprog in `find testProgs -type f -perm 755`; do
  install $testprog %buildroot%_bindir
done

%files
%doc COPYING README
%_bindir/*

%files -n lib%name-%live_soversion
%_libdir/libBasicUsageEnvironment.so.*
%_libdir/libgroupsock.so.*
%_libdir/libliveMedia.so.*
%_libdir/libUsageEnvironment.so.*

%files -n lib%name-devel
%_libdir/libBasicUsageEnvironment.so
%_libdir/libgroupsock.so
%_libdir/libliveMedia.so
%_libdir/libUsageEnvironment.so
%_includedir/BasicUsageEnvironment/
%_includedir/groupsock/
%_includedir/liveMedia/
%_includedir/UsageEnvironment/

%files -n lib%name-devel-static
%_libdir/libBasicUsageEnvironment*.a
%_libdir/libgroupsock*.a
%_libdir/libliveMedia*.a
%_libdir/libUsageEnvironment*.a

%changelog
* Mon Nov 01 2010 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 0.0.0-alt0.2009.04.20.1
- Rebuilt for soname set-versions

* Tue May 12 2009 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2009.04.20
- 2009.04.20 version.
- Introduced shared library (thanks Fedora and Debian folks for patches).

* Thu Aug 14 2008 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2008.07.25
- 2008.07.25 version.

* Tue Nov 06 2007 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2007.11.01
- 2007.11.01 version.

* Wed Aug 22 2007 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2007.08.03a
- 2007.08.03a version.

* Wed Jun 27 2007 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2007.05.24
- 2007.05.24 version.

* Wed May 02 2007 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2007.04.24a
- 2007.04.24a version.

* Sun Mar 04 2007 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2007.02.20
- 2007.02.20 version.

* Thu Sep 07 2006 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2006.09.07
- 2006.09.07 version.

* Sun Aug 13 2006 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2006.08.07
- 2006.08.07 version.
- Renamed to live555.

* Mon Jul 17 2006 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2006.07.04
- 2006.07.04 version.

* Fri Jun 02 2006 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2006.05.17
- 2006.05.17 version.

* Tue May 16 2006 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2006.05.15
- 2006.05.15 version.

* Sat Dec 10 2005 Pavlov Konstantin <thresh@altlinux.ru> 0.0.0-alt0.2005.12.09
- Initial build for ALT Linux.
- specfile is based on Mandriva's spec.

